//
//  DanmakuView.m
//  Danmaku
//
//  Created by 田中 on 07/12/24.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "DanmakuView.h"
#import "Dan.h"


@implementation DanmakuView

NSMutableArray* Dans;	//	Danクラスを入れておく配列

- (void)performAnimation:(NSTimer *)aTimer {
    [self setNeedsDisplay:YES];
}
//	描画
- (void)drawRect:(NSRect)rect 
{ 
	for (Dan* Dan in Dans) {	//	配列からDanを順に取り出して処理
		[Dan draw:rect];		//	Danの描画
	}
} 
//	全てのDanを削除
-(IBAction)clearAll:(id)sender
{
	[Dans removeAllObjects];
}

// マウスダウンが発生したときに呼ばれます 
- (void)mouseDown:(NSEvent*)event 
{ 
    // クリックした座標を、ビュー座標系に変換します 
    clickPoint = [self convertPoint:[event locationInWindow] fromView:nil]; 
 	//		配列に追加   
	[Dans addObject:[[Dan alloc] initWithMx:(float)clickPoint.x my:(float)clickPoint.y]];
	
    // 再描画を行うようにリクエスを出します 
    [self setNeedsDisplay:YES]; 
} 

//	マウスドラッグ時に呼ばれます
- (void)mouseDragged:(NSEvent *)event {
    NSPoint eventLocation = [event locationInWindow];
	
	//	クリックした位置をViewの座標系に変換します。
    clickPoint = [self convertPoint:eventLocation fromView:nil];		
	//		配列に追加
	[Dans addObject:[[Dan alloc] initWithMx:(float)clickPoint.x my:(float)clickPoint.y]];	
	
	[self setNeedsDisplay:YES];
}
//	Viewが作成される最初の初期化時によばれます。
- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
		Dans = [NSMutableArray array];		//	配列を作成
		
		timer = [NSTimer scheduledTimerWithTimeInterval:(1.0/60.0) 
												 target:self 
											   selector:@selector(performAnimation:) 
											   userInfo:nil repeats:YES];	//	タイマーを作成
    }
	
    return self;
}
@end